#!C:\Python27\python.exe
#!/usr/bin/env python
#
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#
""" A tool for editing GNU Radio out-of-tree modules. """

from gnuradio.modtool import *


def main():
    """ Here we go. Parse command, choose class and run. """
    cmd_dict = get_class_dict(globals().values())
    command = get_command_from_argv(cmd_dict.keys())
    if command is None:
        print 'Usage:' + Templates['usage']
        exit(2)
    modtool = cmd_dict[command]()
    try:
        (options, args) = modtool.parser.parse_args()
        modtool.setup(options, args)
        modtool.run()

    except ModToolException as err:
        print >> sys.stderr, err
        exit(1)

if __name__ == '__main__':
    try:
        main()
    except KeyboardInterrupt:
        pass

